

;; Entry point, we need to have our own, to not initialize SPLIM ..

;; In large copy,paste from the microchip crt0/crt1 startup code.
;; Strip down everything unnecessary


.text
.section .init,code
.global	__reset
.global __resetALT
__reset:
__resetALT:

	mov #__SP_init, w15
	nop
	nop
	nop
	
	rcall    __psv_init
	mov      #__dinit_tbloffset,w0 ; w0,w1 = template
    mov      #__dinit_tblpage,w1   ;
    rcall    __data_init_standard  ; initialize data
    
    call  _main                ; call user's main()
    
    reset                      ; reset the processor
	
__psv_init:
	.equiv   PSV, 0x0002
	bclr     _CORCON,#PSV        ; disable PSV (default)
    mov      #__const_length,w0  ;
	cp0      w0                  ; test length of constants
    bra      z,1f                ; br if zero

    mov      #__const_psvpage,w0 ;
    mov      w0,_PSVPAG          ; PSVPAG = psvpage(constants)
    bset     _CORCON,#PSV        ; enable PSV

1:  return                       ;  and exit

__data_init_standard:
	.equiv   FMT_CLEAR,0    ;  format codes
    .equiv   FMT_COPY2,1    ;
    .equiv   FMT_COPY3,2    ;
#define ZERO      w0
#define TLOFFSET  w1
#define DSTOFFSET w2
#define LEN       w3
#define UPPERBYTE w4
#define FORMAT    w5
#define PAGE      w6
#define REALLY_INIT w7

	mov #0x1000-1, w8
	mov #0x11c6-1, w9


    mov       w1,_TBLPAG
    mov       w0,w1
    clr       w0
    bra      4f

1:  inc2      w1,w1
    addc     _TBLPAG                         ; ZERO must be tied to 0

    tblrdl.w [w1],w3
    add      w1,#2,w1
    addc     _TBLPAG                         ; ZERO must be tied to 0

    tblrdl.w [w1],w5
    add      w1,#2,w1
    addc     _TBLPAG                         ; ZERO must be tied to 0

    clr      w4
    lsr      w5,#7,w6                  ; PAGE <- stored DSWPAG
    and      #0x7F,w5                    ; zero out upper bits
    cp.b     w5,#FMT_CLEAR
    bra nz,  2f

    ;; FMT_CLEAR - clear destination memory
9:  
	clr.b    [w2++]
    dec      w3,w3
    bra gtu, 9b                              ; loop if not done
    bra      4f

    ;; FMT_COPY2, FMT_COPY3
2:  cp       w5,#FMT_COPY2
    bra z,   3f

    setm     w4

    ;; standard memcpyd3
3:  rcall __memcpypd3_std

4:  tblrdl.w [w1],w2
	cp0      w2
	bra nz,  1b
	return
	
__memcpypd3_std:
1:
   	 tblrdl.b [w1++],[w2++]  ; dst++ = lo byte
    dec      w3,w3          ; num--
    bra      z,2f           ; br if done         ( add one )

    tblrdl.b [w1--],[w2++]  ; dst++ = hi byte
    dec      w3,w3          ; num--
    bra      z,4f           ; br if done         ( add two )

    cp0      w4             ; test upper flag
    bra      nz,1f           ; br if false

3:  add      w1,#2,w1
    addc     _TBLPAG
    bra      1b

1:
	tblrdh.b [w1],[w2++]    ; dst++ = upper byte
    dec      w3,w3          ; num--
    bra      nz,3b          ; br if not done

4:  inc      w1,w1
2:  add      w1,#1,w1
    addc     _TBLPAG
    return                  ; exit
   